// DECK CLASS For Billy D. Spelchan's Guide to Flash Game Development
// 
// This version of the class is intended only to aid in the understanding of material presented
// in the book "Billy D. Spelchan's Guide to Flash Game Development" and is not for distribution. 
// For more information please read the license.txt file on the disk.
//
// Please check the OpenSource directory for the distributable version of this class.
function Deck()
{
	this.cardArray = new Array(52);
	for (var cntr = 0; cntr < 52; ++cntr)
		this.cardArray[cntr] = cntr + 1;
	this.nextCardIndex = 0;
}

Deck.prototype.shuffle = function()
{
	var cntr, temp, rnd;
	
	for (cntr = 0; cntr < 52; ++cntr)
	{
		rnd = Math.floor(Math.random() * 52);
		temp = this.cardArray[cntr];
		this.cardArray[cntr] = this.cardArray[rnd];
		this.cardArray[rnd] = temp;
	}
	this.nextCardIndex = 0;
}

Deck.prototype.draw = function()
{
	var rv = this.cardArray[this.nextCardIndex];
	++this.nextCardIndex;
	return rv;
}

Deck.prototype.cloneDeck = function(source)
{
	for (var cntr = 0; cntr < 52; ++cntr)
	{
		this.cardArray[cntr] = source.cardArray[cntr];
	}
	this.nextCardIndex = source.nextCardIndex;
}
